(function() {
    tinymce.create('tinymce.plugins.HTButtons', {
        HTButtons : function(ed, url) {
            //add the htshortcodes-buttons cmd
            ed.addCommand('htshortcodes-buttons', function() {
                
               
                var completeAction = function(values){
                    console.log(values);
                    var returnText = '';
                    var buttonColor = extractOptionFromSerializedArray(values, 'btn-color');
                    var textColor = extractOptionFromSerializedArray(values, 'text-color');
                    var btnText = extractOptionFromSerializedArray(values, 'btn-text');
                    var buttonNewWindow = '';
                    try{
                        buttonNewWindow = extractOptionFromSerializedArray(values, 'new-window');
                        buttonNewWindow = 'true';
                    } catch (err){
                        //key not in array
                    }
                    
                    var btnUrl = extractOptionFromSerializedArray(values, 'btn-url');
                    returnText = '[ht_button url="'+btnUrl+'" font_color="'+textColor+'" bg_color="'+buttonColor+'" new_window="'+buttonNewWindow+'"';
                    returnText +=  getGlobalShortcodeVariables(values);
                    returnText +=  ']';
                    returnText += btnText + '[/ht_button]';
                    ed.execCommand('mceInsertContent', 0, returnText);
                }

                //helpers
                var windowTitleHelper = htShortcodesPHPData.shortcodeButtonWindowTitle;
                var textHelper = htShortcodesPHPData.shortcodeButtonTextHelper;
                var urlHelper = htShortcodesPHPData.shortcodeButtonURLHelper;
                var bgColorHelper = htShortcodesPHPData.shortcodeButtonBgColorHelper;
                var textColorHelper = htShortcodesPHPData.shortcodeButtonTextColorHelper;
                var newWindowHelper = htShortcodesPHPData.shortcodeButtonNewWindowHelper;

                //values
                var selectedText = ed.selection.getContent();
                var buttonColor = '#00868B';
                var textColor = '#fff';
                var btnUrl = '';


                var form =  "<div id='ht-shortcodes-button-entry'>";
                form +=         "<input id='ht-shortcodes-button-button-url' name='btn-url' type='text' placeholder='"+urlHelper+"' value='"+btnUrl+"'>";
                form +=         "<input id='ht-shortcodes-button-button-text' name='btn-text' type='text' placeholder='"+textHelper+"' value='"+selectedText+"'>";
                form +=         "<input class='ht-sc-color-picker' id='ht-shortcodes-button-button-color' name='btn-color' type='text' value='"+buttonColor+"'>";
                form +=         ""+bgColorHelper+"<br/>";
                form +=         "<input class='ht-sc-color-picker' id='ht-shortcodes-button-text-color' name='text-color' type='text' value='"+textColor+"'>";
                form +=         ""+textColorHelper+"<br/>";
                form +=         "<br/>";
                form +=         "<input id='ht-shortcodes-button-new-window' name='new-window' type='checkbox' value='new_window'>";
                form +=         ""+newWindowHelper+"<br/>";
                form +=     "</div>";


                var validation = jQuery('#ht-shortcodes-modal-form');
                displayModal(form, completeAction, validation, windowTitleHelper);
                jQuery('input.ht-sc-color-picker').wpColorPicker();
            }); 
        }

    });
    // Register plugin
    tinymce.PluginManager.add( 'htbuttons', tinymce.plugins.HTButtons );
})();
