<?php
/**
* Support Helper Files
*/

//exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;


if( ! class_exists( 'HT_KnowAll_Support_Helpers' ) ){

	class HT_KnowAll_Support_Helpers{

		//constructor 
		function __construct(){
			//hooks
			add_action( 'admin_notices', array( $this, 'ht_knowall_activation_reminder' ), 10 );
		}

		function ht_knowall_activation_reminder(){
			$screen = get_current_screen();
			$theme_license_status = get_option( 'knowall_license_key_status', false );
			$hide_knowall_activation_reminder = apply_filters( 'hide_knowall_activation_reminder', false );
			if( is_a($screen, 'WP_Screen') && 'appearance_page_knowall-license' != $screen->id && 'appearance_page_knowall-welcome' != $screen->id && 'valid' != $theme_license_status && !$hide_knowall_activation_reminder ):
			    ?>
			    <div class="notice notice-info is-dismissible">
			        <p>
			        	<?php _e( 'Your KnowAll key is not activated, you could be missing important updates and support.', 'knowall' ); ?> 
			        	<a href="<?php echo admin_url( 'themes.php?page=knowall-license' ); ?>"><?php _e( 'Activate Now', 'knowall' ); ?></a>		        	
			        </p>
			    </div>
			    <?php
			endif;
		}
		
	}

}

if( class_exists( 'HT_KnowAll_Support_Helpers' ) ){
	$ht_knowall_support_helpers = new HT_KnowAll_Support_Helpers();
}