// Start Wrapper
jQuery(document).ready( function($) {
	'use strict';

	// Smooth Scroll
	$(function() {
	  $('a[href*="#"]:not([href="#"])').click( function() {
	    if (location.pathname.replace(/^\//,'') == this.pathname.replace(/^\//,'') && location.hostname == this.hostname) {
	      var target = $(this.hash);
	      target = target.length ? target : $('[name=' + this.hash.slice(1) +']');
	      if (target.length) {
	        $('html,body').animate({
	          scrollTop: target.offset().top
	        }, 1000);
	        return false;
	      }
	    }
	  } ) ;
	} );

	// Mobile Nav Toggle
	$('#ht-navtoggle').on( 'click', function(e) {
		$('#ht-navtoggle, .ht-global-overlay').toggleClass("active");
		e.preventDefault();
    } );

	// HKB searching event
	$('.hkb-site-search__field').keypress( function() {
		$('body').addClass( 'htevent-hkb-searching' );
	} );
	$( '.hkb-site-search__field' ).blur( function() {
   		$('body').removeClass( 'htevent-hkb-searching' );
	} );

	// Setup for mobile nav
	function setSiteHeaderVariables() {
		var headerHeight = $('.site-header__banner').outerHeight(true);
	  	var adminBarHeight = $('#wpadminbar').outerHeight(true);

		$('.ht-global-overlay').css({ 'top': headerHeight + adminBarHeight });
		$('.nav-header__menuwrapper').css({ 'top': headerHeight });
	}

	// New Affix Setup
	function affixSetup(){

		// Get element heights
		var headerHeight = $('.site-header').outerHeight(true);
		var pageHeaderHeight = $('.ht-pageheader').outerHeight(true);
		var footerheight = $('.site-footer').outerHeight(true);
		var adminBarHeight = $('#wpadminbar').outerHeight(true);

		var htPage = $('.ht-page');
		var htPagePadTop = htPage.css('padding-top').replace(/[^-\d.]/g, '');
		var htPagePadBottom = htPage.css('padding-bottom').replace(/[^-\d.]/g, '');

		// Convert string to numbers
		htPagePadTop = parseInt(htPagePadTop);
		htPagePadBottom = parseInt(htPagePadBottom);

		var articleHeight = $('.hkb-article').outerHeight(true);
		var sidebarHeight = $('.sidebar--sticky').outerHeight(true);

		var articleLastUpdatedHeight = $('.hkb-article__lastupdated').outerHeight(true);
		var articleAttachmentsHeight = $('.hkb-article-attachments').outerHeight(true);
		var articleTagsHeight = $('.hkb-article-tags').outerHeight(true);
		var articleFeedbackHeight = $('.hkb-feedback').outerHeight(true);
		var articleAuthorHeight = $('.hkb-article-author').outerHeight(true);
		var articleRelatedHeight = $('.hkb-article-related').outerHeight(true);
		var articleCommentsHeight = $('.ht-commentslist').outerHeight(true);		

		// Set width of inner-container
		$( '.sidebar--sticky' ).each(function() {
		  var sidebar = $( this );

		  //calculate sidebar width and add it as a style attribute to the sidebar
		  var sidebarWidth = sidebar.width();
		  $( this ).children().attr( 'style', 'width: ' + sidebarWidth + 'px' );

		 });

		//console.log('adminBarHeight');
		//console.log(adminBarHeight);

		// Start Affix

		// First check sidebar isn't bigger than content (otherwise buggy behavior)
		if (articleHeight > sidebarHeight ) {

			// Setup affix
			$('.sidebar__innercontainer--affix').affix( {
			  offset: {
			    top: headerHeight + pageHeaderHeight + htPagePadTop - adminBarHeight,
			    bottom: articleLastUpdatedHeight + articleAttachmentsHeight + articleTagsHeight + articleFeedbackHeight + articleAuthorHeight + articleRelatedHeight + articleCommentsHeight + htPagePadBottom + footerheight + 44,
			  }
			} );

		}
	}

	
	//inital load
	$( window ).load( function () {
	  setSiteHeaderVariables();
	  kbArchiveHeights();
	  affixSetup();
	} ); 


	//window resize
	$( window ).resize( function() {
	  setSiteHeaderVariables();
	  kbArchiveHeights();
	  affixSetup();
	} );
 

	// Attachments Toggle
	$(".hkb-article-attachments").click(function () {
		$(this).toggleClass('hkb-article-attachments--active');	  
	});

	function kbArchiveHeights(){
		// archive category height equalling
		if ( $( '.hkb-archive--style1 .hkb-archive--style3 .hkb-archive--style4 .hkb-archive--style5 .hkb-archive--style6' ).length ) {
	 
	    	var maxHeight = -1;

			$('.hkb-archive li').each(function() {
			 maxHeight = maxHeight > $(this).height() ? maxHeight : $(this).height();
			});

			$('.hkb-archive li').each(function() {
			 //$(this).height(maxHeight);
			 $('.hkb-archive .hkb-category.hkb-category--hasdesc a').css('min-height', maxHeight);
			});

		}
	}

	var counter = 0;

	// Ensure first item in TOC is always active
	$(document.body).on('ht.nav.process', function(){
		if($('#navtoc li.active').length<1){
			$('#navtoc li').first().addClass('active');
		}
	});


// End Wrapper
} );